#include <iostream>
#include <string>
#include <cmath>
#include <fstream>
#include <sstream>
using namespace std;

class Poly
{
	public:
		Poly();  //Default constructor
		Poly(char var);  //Constructor
		~Poly(); //Destructor
		
		void read(string& pstr);
		void print();
		void setCoef(int coef, int expo);
		const Poly operator*(const Poly&);
		char getVar();// access to variable
	
	private:
		char var;
		int term[51];
};						   
void readFile(string fileName, Poly poly[], int& count); 
//******************************************************************************
Poly::Poly(){
	var=' ';
	for(int i=0; i<51 ; i++)
		term[i]=0;
}
Poly::Poly(char n){
	var=n;
	for(int i=0; i<51; i++)
		term[i]=0;
}	
Poly::~Poly(){	
}

//******************************************************************************
void Poly::read(string& pstr){
	char v;
	int c=1, e=0;
	stringstream s1;
	
	for(int i=0; i<pstr.length(); i++){
     	if(pstr[i] == " ") 
     		pstr.erase(i,1); //earse(where to start, lentgh)
	}
	int len=pstr.length();
	int st=0;
	for (int i=0; i<6; i++){ //each term
		s1.str("");
		c = 0;
		while(st<len){
			if(!isalnum(pstr[st])){
				if(pstr[st]=='-'){
					s1<<pstr[st];
				}
				st++;
				continue;	
			}
			if(isdigit(pstr[st])){
				s1<<pstr[st];
				st++;
				continue;
			}else
				break;	
		}
		//cout<<s1.str()<<":"<<pstr[st]<<endl;
		if(s1.str()!="")
			c=atoi(s1.str().c_str());
		else if(s1.str().compare("-")==0)
			c=-1;
		else
			c=1;
			
		if(isalpha(pstr[st])){
			v=pstr[st];
			st++;	
		}else{
			setCoef(c,0);
			//cout << "coef: " << c << "pow: 0"<< endl << endl;
		}
		if(pstr[st]=='^'){
			st++;
			e=atoi(&pstr[st]);
			setCoef(c,n);
			//cout << "coef: " << c << "pow: " << n << endl;
			st++;
		}else if(isalpha(pstr[st-1])){
			e=1;
			setCoef(c,e);
			//cout << "coef: " << c << "pow: " << n << endl;
		}
		if(st>=len)
			break;
	}
} 

void Poly::print(){
	bool first=true;
	for (int i=50; i>1; i--){
		if(term[i] != 0){
			if(first == true){	
				if(term[i]>1)
					cout << term[i] << var << "^" << i ;
				else if(term[i] == 1)
					cout << var << "^" << i;
				else if(term[i] == -1)
					cout << "- " << var << "^" << i;
				else 
					cout << "- " << term[i]*-1 <<var <<"^" << i ;
				first = false;
			}else{
				if(term[i]>1)
					cout << " + " << term[i] << var << "^" << i ;
				else if(term[i] == 1)
					cout << " + " << var << "^" << i ;
				else if(term[i] == -1)
					cout << " - " << var << "^" << i ;
				else
					cout << " - " << term[i]*-1 << var << "^" << i ; 
			}
		}
	}
	//when coef=1, skip printing out 1
	if(term[1] != 0){
		if(first == true){
			if(term[1]>1)
				cout << term[1] << var ;
			else if(term[1] == 1)
				cout << var ;
			else if(term[1] == -1)
				cout <<"- " << var ;
			else 
				cout <<"- " << term[1]*-1 <<var ;
			first = false;
		}else{
			if(term[1]>1)
				cout << " + " << term[1] << var ;
			else if(term[1] == 1)
				cout << " + " << var ;
			else if(term[1] == -1)
				cout << " - " << var ;
			else
				cout << " - " << term[1]*-1 << var ;
		}
	}
	//constant term, print number only
	if(term[0] != 0){
		if(first == true){
			if(term[0]>0)
				cout << term[0];
			else
				cout << "- " << term[0]*-1;
		}else{
			if(term[0]>0)
				cout << " + " << term[0];
			else
				cout << " - " << term[0]*-1;
		}
	}	
	cout << endl;  
}

const Poly Poly::operator*(const Poly& p){ 
	Poly pp;
	int c;
	pp.var = p.var;
	for (int i=0; i<51; ++i){
		for (int j=0; j<51-i; ++j){
			c = this->term[i]*p.term[j];
			pp.term[i+j] += c;
		}
	}
	return pp;
}

char Poly::getVar(){
	return var;
}

void Poly::setCoef(int coef, int expo){
	this->term[expo] = coef;
}

//******************************************************************************
void readFile(string fileName, Poly poly[], int& count) 
{
	fileName = fileName + ".txt";
	ifstream input(fileName.c_str());
	while(!input.eof()){
		string s;
		getline(input, s);
		if(s == "")
			continue;
		poly[count].read(s);
		count ++;
	}
	input.close();
}

//******************************************************************************
int main()
{
	int pNum = 0;  //number of polynominals
	Poly poly[350]; 

	string s; 
	getline(cin, s);
	istringstream iss(s);  //seperate file name
	string fName;
	while(iss>>fName)
		readFile(fName, poly, pNum);  // store all files of polynomials to poly[]
	
	char v; 
	while(cin.get(v)) {
        Poly temp;
		temp.setCoef(1,0);
		for (int i=0; i<pNum; ++i){
			if(v == poly[i].getVar())
				temp = temp*poly[i];
		}
		if (isalpha(v))
			temp.print();
    }

return 0;
}

